---
title: AuthenticatorAssertionResponse
slug: Web/API/AuthenticatorAssertionResponse
tags:
  - API
  - Authentication
  - AuthenticatorAssertionResponse
  - Interface
  - Reference
  - Web Authentication API
  - WebAuthn
---
<div>{{APIRef("Web Authentication API")}}{{securecontext_header}}</div>

<p>The <code><strong>AuthenticatorAssertionResponse</strong></code> interface of the <a href="/en-US/docs/Web/API/Web_Authentication_API">Web Authentication API</a> is returned by {{domxref('CredentialsContainer.get()')}} when a {{domxref('PublicKeyCredential')}} is passed, and provides proof to a service that it has a key pair and that the authentication request is valid and approved.</p>

<p>This interface inherites from {{domxref("AuthenticatorResponse")}}.</p>

<div class="note">
<p><strong>Note:</strong> This interface is restricted to top-level contexts. Use from within an {{HTMLElement("iframe")}} element will not have any effect.</p>
</div>

<h2 id="Properties">Properties</h2>

<dl>
 <dt><code>AuthenticatorAssertionResponse.clientDataJSON</code> {{securecontext_inline}}{{readonlyinline}}</dt>
 <dd>The client data for the authentication, such as origin and challenge. The {{domxref("AuthenticatorAttestationResponse.clientDataJSON","clientDataJSON")}} property is inherited from the {{domxref("AuthenticatorResponse")}}.</dd>
 <dt>{{domxref("AuthenticatorAssertionResponse.authenticatorData")}} {{securecontext_inline}}{{readonlyinline}}</dt>
 <dd>An {{jsxref("ArrayBuffer")}} containing information from the authenticator such as the Relying Party ID Hash (rpIdHash), a signature counter, test of user presence and user verification flags, and any extensions processed by the authenticator.</dd>
 <dt>{{domxref("AuthenticatorAssertionResponse.signature")}} {{securecontext_inline}}{{readonlyinline}}</dt>
 <dd>An assertion signature over {{domxref("AuthenticatorAssertionResponse.authenticatorData")}} and {{domxref("AuthenticatorResponse.clientDataJSON")}}. The assertion signature is created with the private key of keypair that was created during the {{domxref("CredentialsContainer.create()","navigator.credentials.create()")}} call and verified using the public key of that same keypair.</dd>
 <dt>{{domxref("AuthenticatorAssertionResponse.userHandle")}} {{securecontext_inline}}{{readonlyinline}}</dt>
 <dd>An {{jsxref("ArrayBuffer")}} containing an opaque user identifier.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">var options = {
  challenge: new Uint8Array([/* bytes sent from the server */])
};

navigator.credentials.get({ "publicKey": options })
    .then(function (credentialInfoAssertion) {
    var assertionResponse = credentialInfoAssertion.response;
    // Do something specific with the response

    // send assertion response back to the server
    // to proceed with the control of the credential
}).catch(function (err) {
     console.error(err);
});

</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebAuthn', '#iface-authenticatorassertionresponse', 'AuthenticatorAssertionResponse interface')}}</td>
   <td>{{Spec2('WebAuthn')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.AuthenticatorAssertionResponse")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("AuthenticatorAttestationResponse")}}: the interface for the type of response given when creating a new credential</li>
 <li>{{domxref("AuthenticatorResponse")}}: the parent interface</li>
</ul>
